import type { ContentSourceMap, QueryParams } from '@sanity/client';
import type { EncodeDataAttributeFunction } from '@sanity/core-loader/encode-data-attribute';
import type { AsyncDataOptions, AsyncDataRequestStatus } from 'nuxt/app';
import { type Ref } from 'vue';
export interface SanityQueryResponse<T> {
    data: T;
    sourceMap?: ContentSourceMap;
    encodeDataAttribute?: EncodeDataAttributeFunction;
}
interface AsyncDataExecuteOptions {
    _initial?: boolean;
    dedupe?: boolean;
}
export interface _AsyncSanityData<T, E> {
    data: Ref<T>;
    sourceMap: Ref<ContentSourceMap | null>;
    encodeDataAttribute: Ref<EncodeDataAttributeFunction | (() => void)>;
    pending: Ref<boolean>;
    refresh: (opts?: AsyncDataExecuteOptions) => Promise<void>;
    execute: (opts?: AsyncDataExecuteOptions) => Promise<void>;
    error: Ref<E | null>;
    status: Ref<AsyncDataRequestStatus>;
}
export type AsyncSanityData<T, E> = _AsyncSanityData<T, E> & Promise<_AsyncSanityData<T, E>>;
export interface UseSanityQueryOptions<T> extends AsyncDataOptions<T> {
    client?: 'default' | 'minimal';
    perspective?: 'previewDrafts' | 'published' | 'raw';
}
export declare const useSanityQuery: <T = unknown, E = Error>(query: string, _params?: QueryParams, _options?: UseSanityQueryOptions<SanityQueryResponse<T | null>>, lazy?: boolean) => AsyncSanityData<T | null, E>;
export {};
